package com.qmth.digit.print.api;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.qmth.boot.api.annotation.Aac;
import com.qmth.boot.api.annotation.BOOL;
import com.qmth.boot.api.constant.ApiConstant;
import com.qmth.digit.print.business.bean.ApiUser;
import com.qmth.digit.print.business.bean.dto.BlurryUserDto;
import com.qmth.digit.print.business.bean.dto.ExamTaskDto;
import com.qmth.digit.print.business.bean.query.BlurryParam;
import com.qmth.digit.print.business.bean.query.ExamTaskParam;
import com.qmth.digit.print.business.entity.BasicCourse;
import com.qmth.digit.print.business.service.ExamTaskService;
import com.qmth.digit.print.business.util.RequestUtils;
import com.qmth.digit.print.common.util.Result;
import com.qmth.digit.print.common.util.ResultUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * <p>
 * 命题任务 前端控制器
 * </p>
 *
 * @author xf
 * @since 2021-03-23
 */
@Api(tags = "命题任务Controller")
@RestController
@RequestMapping(ApiConstant.DEFAULT_URI_PREFIX + "/${prefix.url.exam}/task")
@Aac(auth = BOOL.FALSE)
public class ExamTaskController {

    @Autowired
    private ExamTaskService examTaskService;

    /**
     * 查询
     * @param request
     * @param param
     * @return
     */
    @ApiOperation(value = "查询")
    @RequestMapping(value = "/list", method = RequestMethod.GET)
    public Result list(HttpServletRequest request, ExamTaskParam param){
        ApiUser apiUser = RequestUtils.getApiUser(request);
        param.setSchoolId(apiUser.getSchoolId());
        IPage<ExamTaskDto> examTasks = examTaskService.list(param);
        return ResultUtil.ok(examTasks);
    }

    /**
     * 试卷编号模糊查询
     * @param param
     * @return
     */
    @ApiOperation(value = "试卷编号模糊查询")
    @RequestMapping(value = "/paper_number_query", method = RequestMethod.GET)
    public Result paperNumberQuery(HttpServletRequest request, BlurryParam param){
        ApiUser apiUser = RequestUtils.getApiUser(request);
        param.setSchoolId(apiUser.getSchoolId());
        List<String> list = examTaskService.listPaperNumber(param);
        return ResultUtil.ok(list);
    }

    /**
     * 命题老师模糊查询
     * @param param
     * @return
     */
    @ApiOperation(value = "命题老师模糊查询")
    @RequestMapping(value = "/user_query", method = RequestMethod.GET)
    public Result userQuery(HttpServletRequest request, BlurryParam param){
        ApiUser apiUser = RequestUtils.getApiUser(request);
        param.setSchoolId(apiUser.getSchoolId());
        List<BlurryUserDto> list = examTaskService.listUser(param);
        return ResultUtil.ok(list);
    }

}

